$(function() {
  var doc = document.documentElement;
  var body = document.body;
  var content = document.querySelector('.content');
  var menus = document.querySelectorAll('.sidebar');

  var contentMenus = Array.prototype.slice.call(document.querySelectorAll('.content .sidebar'), 0);

  var menu = Array.prototype.slice.call(menus, 0).filter(function(el) {
    return contentMenus.indexOf(el) === -1;
  })[0];



  var header = document.querySelector('.header');

  var links = menu.querySelectorAll('a');
    function updateSidebar() {
      // skip if hidden
      if (!$(menu).is(':visible')) {
        return;
      }

      var top = doc && doc.scrollTop || body.scrollTop
      var headerHeight = $('.header-fixed') ? 0 : $(header).outerHeight(true)
      if (top > headerHeight) {
        $(menu).css({
          position: 'fixed',
          // account for fixed header
          top: $('.header-fixed') ? $('.header-fixed').outerHeight(true) : 0,
          bottom: 0,
          'overflow-x': 'hidden',
          'overflow-y': 'auto',

//          left: $(menu).offset().left
        })
      } else {
        $(menu).css({
          position: '',
          top: '',
          left: '',
          bottom: '',
        })
      }
      var last
      for (var i = 0; i < links.length; i++) {
        var link = links[i];
        if (!$(link).is(':visible')) {
          continue;
        }
        // 20px fudge factor (so that we jump into the next heading a bit before the current one ends)
        if ($($(link).attr('href')).offset().top > top + 20) {
          if (!last) last = link
          break;
        } else {
          last = link
        }
      }
      if (last) setActive(last)
    }

    function setActive (el) {
      var previousActive = menu.querySelector('.active')
      if (el.parentElement !== previousActive) {
        if (previousActive) previousActive.classList.remove('active')
        el.parentElement.classList.add('active');
      }
    }

  updateSidebar();
  window.addEventListener('scroll', updateSidebar);
  window.addEventListener('resize', updateSidebar);

  var sheet;
  function insertRule(selectors, rules) {
    var doc = document;

    if (typeof doc.styleSheets !== 'object') {
      return;
    }
    if (!sheet) {
      if (doc.createStyleSheet) {
        sheet = doc.createStyleSheet();
      } else {
        doc.getElementsByTagName('head')[0].appendChild(doc.createElement('style'));
        sheet = doc.styleSheets[doc.styleSheets.length - 1];
      }
    }
    if (!Array.isArray(selectors)) {
      selectors = [selectors];
    }
    if (sheet.addRule) {
      selectors.forEach(function(selector) {
        sheet.addRule(selector, rules);
      });
    } else {
      sheet.insertRule(selectors.join(',') + ' {' + rules + '}', sheet.cssRules.length);
    }
  }

});
